package annotation

import (
	"reflect"

	cda "git.loafle.net/commons/di-go/annotation"
)

var ServerAnnotationType = reflect.TypeOf((*ServerAnnotation)(nil))

func init() {
	cda.RegisterAnnotation(ServerAnnotationType)
}

type ServerAnnotation struct {
	cda.TypeAnnotation `@annotation:"@app:Server"`

	RootDir   string              `json:"rootDir"`
	Mount     map[string][]string `json:"mount"`
	UploadDir string              `json:"uploadDir"`
	HTTPPort  int16               `json:"httpPort"`
	HTTPSPort int16               `json:"httpsPort"`
}
