package user

import (
	"log"
	"reflect"

	cda "git.loafle.net/commons/di-go/annotation"
	cdr "git.loafle.net/commons/di-go/registry"

	// For annotation
	_ "git.loafle.net/totopia/server/pkg/loafer/web/annotation"
)

var UserServiceType = reflect.TypeOf((*UserService)(nil))

func init() {
	cdr.RegisterType(UserServiceType)
}

type UserService struct {
	cda.TypeAnnotation `annotation:"@web:Service(\"name\": \"/userService\")"`
}

func (us *UserService) FindAll() {
	log.Printf("UserService FindAll")
}
